apiVersion: apps/v1
kind: Deployment
metadata:
  namespace: {{ .Release.Namespace }}
  name: standbyplanning-tomcat-deployment
spec:
  selector:
    matchLabels:
      app: standbyplanning-tomcat
  template:
    metadata:
      labels:
        app: standbyplanning-tomcat
      annotations:
        checksum/config1: {{ include (print $.Template.BasePath "/configmap.yaml") . | sha256sum }}
    spec:
      initContainers:
        - name: init-db
          image: postgres:9.6.22-alpine3.14
          imagePullPolicy: IfNotPresent
          env:
            - name: APP_DB_ROLE
              value: bp
            - name: APP_DB_PASSWORD
              value: bp
            - name: APP_DBNAME
              value: BP-{{ .Values.shortNameEnv | title }}
            - name: PGHOST
              value: postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local
            - name: PGUSER
              value: postgres
            - name: PGPASSWORD
              valueFrom:
                secretKeyRef:
                  name: postgresql-secrets
                  key: POSTGRES_DB_PASSWORD
          command:
            - /bin/sh
            - -c
            - >
              echo Waiting for DB to be ready...;
              while ! pg_isready >dev/null; do sleep 3; done;
              echo DB is ready and accepting conncetions;
              sleep 3;
              echo Creating database ${APP_DBNAME} if not exists;
              psql -tc "SELECT 1 FROM pg_database WHERE datname = '${APP_DBNAME}'" | grep -q 1 || psql -U postgres -c "CREATE DATABASE \"${APP_DBNAME}\"";
              echo Creating role ${APP_DB_ROLE} if not exists;
              psql -tc "SELECT 1 FROM pg_user WHERE usename = '${APP_DB_ROLE}'" | grep -q 1 || psql -c "CREATE USER \"${APP_DB_ROLE}\" WITH PASSWORD '${APP_DB_PASSWORD}'";
              echo Job finished;
      containers:
        - image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: Always
          name: standbyplanning-tomcat
          env:
            - name: JAVA_TOOL_OPTIONS
              value: "-agentlib:jdwp=transport=dt_socket,address=5000,server=y,suspend=n"
            - name: APP_DB_ROLE
              value: bp
            - name: APP_DB_PASSWORD
              value: bp
            - name: APP_DBNAME
              value: BP-{{ .Values.shortNameEnv | title }}
            - name: DATASOURCE_URL
              value: jdbc:postgresql://postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local/$(APP_DBNAME)
            - name: APP_FRONTEND_URL
              value: "{{ .Values.branchSubdomain }}ber.{{ .Values.rootEnvironment }}.{{ .Values.ingressDomain }}"
          ports:
            - containerPort: 5000
              name: "jvm-debug"
            - containerPort: 8080
          volumeMounts:
            - name: config-volume
              mountPath: /usr/local/tomcat/webapps/spbe/WEB-INF/classes/application.properties
              subPath: application.properties
            - name: config-volume
              mountPath: /usr/local/tomcat/webapps/spbe/WEB-INF/applicationContext-persistence.xml
              subPath: applicationContext-persistence.xml
            - name: config-volume
              mountPath: /opt/openkdg/mail.properties
              subPath: mail.properties
      volumes:
        - name: config-volume
          configMap:
            name: standbyplanning-config
---
apiVersion: v1
kind: Service
metadata:
  namespace: {{ .Release.Namespace }}
  name: standbyplanning-service
spec:
  selector:
    app: standbyplanning-tomcat
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8080
